10 CLS
   CLEAR
   PRINT "NRPN Calculator v1.0"
   PRINT ""
   PRINT "(C)Copyright 2009, Rich Weeds Nagel - All rights reserved"
   PRINT ""
   PRINT "Calculate ["; : COLOR 14, 0: PRINT "D"; : COLOR 7, 0: PRINT "]ata Entry MSB # and ["; : COLOR 14, 0: PRINT "D"; : COLOR 7, 0: PRINT "]ata Entry LSB # (using Actual NRPN Value)"
   PRINT "Calculate ["; : COLOR 14, 0: PRINT "A"; : COLOR 7, 0: PRINT "]ctual NRPN Value (using Data Entry MSB # and Data Entry LSB #)"
   PRINT ""
   PRINT "View ["; : COLOR 14, 0: PRINT "R"; : COLOR 7, 0: PRINT "]esults File from Previous Calculations (Results.txt)"
   PRINT "Delete Results ["; : COLOR 14, 0: PRINT "F"; : COLOR 7, 0: PRINT "]ile from Previous Calculations (Results.txt)"
   PRINT ""
   PRINT "View ["; : COLOR 14, 0: PRINT "H"; : COLOR 7, 0: PRINT "]elp and Readme File (NRPNCalc.txt)"
   PRINT ""
   PRINT "["; : COLOR 14, 0: PRINT "Q"; : COLOR 7, 0: PRINT "]uit"
   PRINT ""
   INPUT ; "Select option [D,A,R,H,Q]"; MenuOption$

   IF MenuOption$ = "D" THEN GOTO 20
   IF MenuOption$ = "d" THEN GOTO 20
   IF MenuOption$ = "A" THEN GOTO 30
   IF MenuOption$ = "a" THEN GOTO 30
   IF MenuOption$ = "R" THEN GOTO 40
   IF MenuOption$ = "r" THEN GOTO 40
   IF MenuOption$ = "F" THEN GOTO 70
   IF MenuOption$ = "f" THEN GOTO 70
   IF MenuOption$ = "H" THEN GOTO 80
   IF MenuOption$ = "h" THEN GOTO 80
   IF MenuOption$ = "Q" THEN GOTO 90
   IF MenuOption$ = "q" THEN GOTO 90

   IF NOT MenuOption$ = "D" THEN GOTO 10 ELSE
   IF NOT MenuOption$ = "d" THEN GOTO 10 ELSE
   IF NOT MenuOption$ = "A" THEN GOTO 10 ELSE
   IF NOT MenuOption$ = "a" THEN GOTO 10 ELSE
   IF NOT MenuOption$ = "R" THEN GOTO 10 ELSE
   IF NOT MenuOption$ = "r" THEN GOTO 10 ELSE
   IF NOT MenuOption$ = "F" THEN GOTO 10 ELSE
   IF NOT MenuOption$ = "f" THEN GOTO 10 ELSE
   IF NOT MenuOption$ = "H" THEN GOTO 10 ELSE
   IF NOT MenuOption$ = "h" THEN GOTO 10 ELSE
   IF NOT MenuOption$ = "Q" THEN GOTO 10 ELSE
   IF NOT MenuOption$ = "q" THEN GOTO 10

20 CLS
   GOTO 25

25 CLEAR
   ON ERROR GOTO 20

   INPUT ; "Enter actual NRPN value (or .1 to return to the main menu)"; ActualValue
   IF ActualValue = .1 GOTO 10

   TemporaryValue = ActualValue + 8192

   TemporaryDataEntryMSB = TemporaryValue / 128
   DataEntryMSB = INT(TemporaryDataEntryMSB)

   DataEntryLSB = TemporaryValue MOD 128

   REM Note that the "MOD" above is "Modulo" arithmetic. Modulo arithmetic is
   REM denoted by the modulus (or "remainder") operator "MOD". Modulo
   REM arithmetic provides the remainder, rather than the quotient, of an
   REM integer division. Hence, the LSB calculation above is the same as the
   REM following formula:

   REM TemporaryDataEntryLSB = TemporaryValue / 128
   REM TemporaryDataEntryLSB = INT(TemporaryDataEntryLSB)
   REM TemporaryDataEntryLSB = TemporaryDataEntryLSB * 128
   REM DataEntryLSB = TemporaryValue - TemporaryDataEntryLSB

   PRINT ""
   PRINT ""
   PRINT "Actual NRPN Value ="; ActualValue
   PRINT "Data Entry MSB # ="; DataEntryMSB
   PRINT "Data Entry LSB # ="; DataEntryLSB
   PRINT ""
   OPEN "RESULTS.TXT" FOR APPEND ACCESS READ WRITE AS #1
   PRINT #1, "Actual NRPN Value ="; ActualValue
   PRINT #1, "Data Entry MSB # ="; DataEntryMSB
   PRINT #1, "Data Entry LSB # ="; DataEntryLSB
   PRINT #1, ""
   GOTO 25

30 CLS
   GOTO 35

35 CLEAR
   ON ERROR GOTO 30

   INPUT ; "Enter Data Entry MSB # (or .1 to return to the main menu)"; DataEntryMSB
   IF DataEntryMSB = .1 GOTO 10

   PRINT ""

   INPUT ; "Enter Data Entry LSB # (or .1 to return to the main menu)"; DataEntryLSB
   IF DataEntryLSB = .1 GOTO 10

   TemporaryValue = DataEntryMSB * 128
   TemporaryValue = TemporaryValue + DataEntryLSB
   ActualValue = TemporaryValue - 8192

   PRINT ""
   PRINT ""
   PRINT "Actual NRPN Value ="; ActualValue
   PRINT "Data Entry MSB # ="; DataEntryMSB
   PRINT "Data Entry LSB # ="; DataEntryLSB
   PRINT ""
   OPEN "RESULTS.TXT" FOR APPEND ACCESS READ WRITE AS #1
   PRINT #1, "Actual NRPN Value ="; ActualValue
   PRINT #1, "Data Entry MSB # ="; DataEntryMSB
   PRINT #1, "Data Entry LSB # ="; DataEntryLSB
   PRINT #1, ""
   GOTO 35

40 CLS
   PRINT "View Results File"
   PRINT ""
   PRINT "View results file from previous calculations (Results.txt) using:"
   PRINT ""
   PRINT "["; : COLOR 14, 0: PRINT "M"; : COLOR 7, 0: PRINT "]S-DOS Editor"
   PRINT "["; : COLOR 14, 0: PRINT "W"; : COLOR 7, 0: PRINT "]indows Notepad"
   PRINT ""
   PRINT "["; : COLOR 14, 0: PRINT "R"; : COLOR 7, 0: PRINT "]eturn to Main Menu"
   PRINT ""
   INPUT ; "Select option [M,W,R]"; MenuOption$

   IF MenuOption$ = "M" THEN GOTO 50
   IF MenuOption$ = "m" THEN GOTO 50
   IF MenuOption$ = "W" THEN GOTO 60
   IF MenuOption$ = "w" THEN GOTO 60
   IF MenuOption$ = "R" THEN GOTO 10
   IF MenuOption$ = "r" THEN GOTO 10

   IF NOT MenuOption$ = "M" THEN GOTO 40 ELSE
   IF NOT MenuOption$ = "m" THEN GOTO 40 ELSE
   IF NOT MenuOption$ = "W" THEN GOTO 40 ELSE
   IF NOT MenuOption$ = "w" THEN GOTO 40 ELSE
   IF NOT MenuOption$ = "R" THEN GOTO 40 ELSE
   IF NOT MenuOption$ = "r" THEN GOTO 40

50 SHELL "EDIT.COM RESULTS.TXT"
   GOTO 10

60 PRINT ""
   PRINT ""
   PRINT "Press ALT+TAB to return to the NRPN Calculator after viewing the results file
   PRINT "in Windows Notepad."
   PRINT ""
   PRINT "Press any key to continue..."
   DO
   LOOP WHILE INKEY$ = ""
   SHELL "NOTEPAD.EXE RESULTS.TXT"
   GOTO 10

70 PRINT ""
   SHELL "DEL RESULTS.TXT /P"
   PRINT ""
   PRINT "Press any key to continue..."
   DO
   LOOP WHILE INKEY$ = ""
   GOTO 10

80 SHELL "EDIT.COM NRPNCALC.TXT"
   GOTO 10

90 FOR x = 1 TO 15
   COLOR x
   PRINT "DOS RULES!!!"
   NEXT x
   FOR x = 1 TO 15
   COLOR x
   PRINT "DOS RULES!!!"
   NEXT x
   FOR A = 100 TO 1000 STEP 100
   B = A + 200
   FOR C = A TO B STEP 10
   SOUND C, .06
   NEXT C
   NEXT A
   FOR D = 1 TO 12
   FOR E = 4000 TO 10 STEP -200
   SOUND E, .05
   NEXT E
   NEXT D
   COLOR 7, 0

